<template>
	<span>
		<button @click="prevWeek">
			<i class="el-icon-arrow-left"></i>
		</button>
		<!-- <button @click="selectDate">
			<i class="el-icon-date"></i>
		</button>-->
		<date-range-control v-model="range" :clearable="false" />
		<button @click="nextWeek">
			<i class="el-icon-arrow-right"></i>
		</button>
	</span>
</template>

<script lang="ts" setup>
import { ref, watch, nextTick } from 'vue-demi';
import { dateAddWeeks, dateEndOfWeek, DateRange, dateStartOfWeek, dateWeekRange } from '../../../lib/utils';
import DateRangeControl from "./DateRangeControl.vue"

interface Props {
	modelValue?: DateRange;
}

const props = defineProps<Props>();
const emit = defineEmits(['update:modelValue']);

const range = ref<DateRange>(getDateRange(new Date()));

updateDateRange(props.modelValue);
watch(() => props.modelValue, updateDateRange);

function getDateRange(date: Date): DateRange {
	return dateWeekRange(date);
}

function selectDate() {

}

function nextWeek() {
	if (!range.value) return;
	updateDateRange(dateAddWeeks(range.value.end, 1));
}

function prevWeek() {
	if (!range.value) return;
	updateDateRange(dateAddWeeks(range.value.begin, -1));
}

async function updateDateRange(value?: Date | DateRange) {
	if (!value) return;

	const oldRange: DateRange = range.value instanceof Date
		? getDateRange(range.value)
		: range.value;

	if (value instanceof Date) {
		value = getDateRange(value);
	}

	const newRange = {
		begin: dateStartOfWeek(value.begin),
		end: dateEndOfWeek(value.end)
	}

	if (oldRange.begin.getTime() === newRange.begin.getTime()
		&& oldRange.end.getTime() === oldRange.end.getTime()) {
		return;
	}

	range.value = newRange;
	emit('update:modelValue', newRange);
}

</script>